#include "channelPreparation.h"

pair<array, mat> isolate_channels( 
    const mat& iq_samples_matrix,
    int ref_position) {
    
    int N = iq_samples_matrix[0].size();
    int Mp1 = iq_samples_matrix.size();

    if (Mp1 > N) {
        cerr << "WARNING: Number of samples is more than the number of antenna channels.\n";
        cerr << "Input matrix may have been flipped.\n";
        cerr << "N: " << N << "\nM+1: " << Mp1 << "\n";
    }

    if (ref_position < 0 || ref_position >= Mp1) {
        cerr << "ERROR: Invalid ref_position. Exitting.\n";
        cerr << "Ref Position: " << ref_position << "\n";
        cerr << "M+1: " << Mp1 << "\n";
        exit(1);
    }

    array ref_channel = iq_samples_matrix[ref_position];
    mat surv_channels(Mp1 - 1);
    int idx = 0;
    for (int i = 0; i < Mp1; ++i) {
        if (i != ref_position) {
            surv_channels[idx++] = iq_samples_matrix[i];
        }
    }

    return {ref_channel, surv_channels};
}

array time_domain_filter_surveillance(array& ref_ch, array& surv_ch, int K/*, int D*/) {
    // vector<vector<int>> subspace_indexes = gen_subspace_indexes(K, D);                                                                  
    // return ECAS(ref_ch, surv_ch, subspace_indexes, 1, 0);

    return Wiener_SMI_MRE(ref_ch, surv_ch, K);
}