#include "helper.h"

using namespace std;

typedef vector<vector<complex<double>>> mat;

//         Description:
//         ------------
//         This function tries to find the position of target reflection peak on the given range-Doppler matrix
//         inside a specified range-Doppler region. To find the true target location, the function search for
//         the maximum value inside this region, which is bounded by the 
//         'range_min'-'range_max' and 'Doppler_min'-'Doppler_max' matrix indicies.
pair<int,int> find_target(mat& rd_matrix, int range_min, int range_max, int Doppler_min, int Doppler_max) {
    auto rd_abs = rd_matrix;
    int rd_matrix_size = rd_matrix.size();
    int rd_matrix_size_cols = rd_matrix[0].size();
    for (int i = 0; i < rd_matrix_size; i++) {
        for (int j = 0 ; j < rd_matrix_size_cols; j++) {
            rd_abs[i][j] = abs(rd_abs[i][j]);
        }
    }

    double max = 0; 
    int argmax_d = 0;
    int argmax_r = 0;

    for (int i = Doppler_min; i < Doppler_max; i++) {
        for (int j = range_min ; j < range_max; j++) {
            if (rd_abs[i][j].real() > max) {
                max = rd_abs[i][j].real();
                argmax_d = i;
                argmax_r = j;
            }
        }
    }

    return {argmax_r, argmax_d};
} 

    

